// Autor: GLo, WV Innovation GmbH
// SOPC Builder Interface fr NAND FLASH 512Mbit
// 18.01.2007

// synthesis translate_off
`timescale 1ns / 100ps
// synthesis translate_on
module NAND_FLASH (
                // Host inputs
                iDATA,
                iALE,
                iCLE,
                iCE_N,
                iRE_N,
                iWE_N,
                iWP_N,

                // Host outputs
                oDATA,
                oRB,

                // NAND_FLASH signals
                ioNAND_DATA,
                oNAND_ALE,
                oNAND_CLE,
                oNAND_CE_N,
                oNAND_RE_N,
                oNAND_WE_N,
                oNAND_WP_N,
                iNAND_RB
               );

  //Host side
  input [7:0]   iDATA;
  input         iALE;
  input         iCLE;
  input         iCE_N;
  input         iRE_N;
  input         iWE_N;
  input         iWP_N;
  output [7:0]  oDATA;
  output        oRB;

  //NAND FLASH side
  inout  [7:0]  ioNAND_DATA;
  output        oNAND_ALE;
  output        oNAND_CLE;
  output        oNAND_CE_N;
  output        oNAND_RE_N;
  output        oNAND_WE_N;
  output        oNAND_WP_N;
  input         iNAND_RB;
 
  //wrapper, which is an e_instance
  NAND_FLASH_IF wrapper
    (
    .iDATA          (iDATA),
    .iALE           (iALE),
    .iCLE           (iCLE),
    .iCE_N          (iCE_N),
    .iRE_N          (iRE_N),
    .iWE_N          (iWE_N),
    .iWP_N          (iWP_N),
    .oDATA          (oDATA),
    .oRB            (oRB),
    .ioNAND_DATA    (ioNAND_DATA),
    .oNAND_ALE      (oNAND_ALE),
    .oNAND_CLE      (oNAND_CLE),
    .oNAND_CE_N     (oNAND_CE_N),
    .oNAND_RE_N     (oNAND_RE_N),
    .oNAND_WE_N     (oNAND_WE_N),
    .oNAND_WP_N     (oNAND_WP_N),
    .iNAND_RB       (iNAND_RB)
    );

endmodule

